# Copyright (C) 2020, 2023 by Thomas Lindner <tom@dl6tom.de>
# Copyright (C) 2020 by Cathy Hu <cathy.hu@fau.de>
# Copyright (C) 2020 by Martin Rey <martin.rey@mailbox.org>
#
# SPDX-License-Identifier: 0BSD

from kibicara.platformapi import Censor, Message, Spawner
from kibicara.platforms.test.model import Test


class TestBot(Censor):
    def __init__(self, test: Test):
        super().__init__(test.hood)
        self.messages: list[Message] = []

    async def run(self):
        while True:
            self.messages.append(await self.receive())


spawner = Spawner(Test, TestBot)
