import { Injectable } from '@angular/core';
import {
  HttpRequest,
  HttpHandler,
  HttpEvent,
  HttpInterceptor,
} from '@angular/common/http';
import { Observable } from 'rxjs';
import { LoginService } from './login.service';

@Injectable()
export class AuthTokenInterceptor implements HttpInterceptor {
  constructor(private loginService: LoginService) {}

  intercept(
    request: HttpRequest<any>,
    next: HttpHandler
  ): Observable<HttpEvent<any>> {
    const token = this.loginService.currentHoodAdminValue;
    if (token && token.access_token) {
      request = request.clone({
        setHeaders: {
          Authorization: 'Bearer ' + token.access_token,
        },
      });
    }
    return next.handle(request);
  }
}
